#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include <unistd.h>
#include <sys/types.h>

#include "struct_ligne.h"
#include "create_line.h"
#include "test_line_value.h"
#include "set_value.h"
#include "search_var.h"

#include "get_conf.h"







/*
void get_var_and_value(struct ligne *list_arg)
{
	if(list_arg == NULL)
		return;
	int iBcl;
	for(iBcl =0;iBcl < 255;iBcl++)
	{
		switch(list_arg->var[iBcl])
		{
			case ' ':
				break;
			case '=':
				break;
			case '\n':
				break;
			default:
		}
	}
	return;
}*/


/*
void get_end_position(struct ligne **p_arg,char *where_section)
{

}*/




/* Use the premz pointer adress to open and create new lines in memory*/
void file_open(struct ligne **p_arg)
{
	FILE *ptr_file=NULL; struct ligne *target=NULL;
	char filename[MAX_LENGTH_LINE],default_name[80]="/etc/samba/smb.conf\0";
	/*int c;*/
	/*do
	{
		printf("Please provide the samba config file name and path.\n");
		printf("Example: /etc/samba/smb.conf\n");
		printf("Complete filename: ");
		fgets(filename,MAX_LENGTH_LINE,stdin);
		filename[strlen(filename)-1] = '\0';
		if(strlen(filename) == 0)*/
			strcpy(filename,default_name);
		ptr_file = fopen(filename,"r");
		if(ptr_file == NULL)
			return;
		printf("Current config readed from: %s\n",filename);/*
	} while(ptr_file == NULL);*/
	while(feof(ptr_file) == 0)
	{
		if(target == NULL)
			target = create_line(p_arg);
		else
			target = create_line(&target);
		if(target == NULL)
		{
			/*printf("error: create_line returned NULL\n");*/
			return;
		}
		/*do
		{
			c = getchar();
		} while(c!= EOF && c!='\n');*/
		fgets(target->var,MAX_LENGTH_LINE, ptr_file);
		if(strlen(target->var)>0)
			test_line_value(target);
		else
		{
			/*printf("Error reading, end of file?\n");*/
			if(target->precedent!=NULL)
				target->precedent->suivant=NULL;
			else
				*p_arg=NULL;
			free(target);
			break;
		}
		/*	get_var_and_value(target);*/
	}
	fclose(ptr_file);
}

/* This function free all malloc done by create_line */
void liberate_memory(struct ligne **p_arg)
{
	struct ligne *current;
	if(p_arg == NULL)
		return;
	current = *p_arg;
	while(current != NULL)
	{
		current = current->suivant;
		free(*p_arg);
		*p_arg = current;
	}
}

/* Dumb function to test set_value() */
void test_look(struct ligne **p_arg)
{
	/*struct ligne *result = NULL;*/
	char get_it[MAX_LENGTH_OPTION], in_section[MAX_LENGTH_OPTION];
	printf("Entrez la chaine recherchée: ");
	fgets(get_it,MAX_LENGTH_OPTION,stdin);
	if(get_it[strlen(get_it)-1] == '\n')
		get_it[strlen(get_it)-1] = '\0';
	/*printf("strlen %d\n",strlen(get_it));*/
	if(strlen(get_it)>0)
	{
		/*result = search_var(list_arg,get_it,"[global]");
		if(result != NULL)
		{
			printf("%s",result->var);
			if(result->is_section == 1)
				printf(" = %s\n",result->value);
		}
		else
			printf("non trouvé dans [global]\n");*/
		printf("Please provide the section name.\n");
		printf("Example: [Printers]\n");
		printf("null is [global] : ");
		fgets(in_section,MAX_LENGTH_OPTION,stdin);
		if(in_section[strlen(in_section)-1] == '\n')
			in_section[strlen(in_section)-1] = '\0';
		if(strlen(in_section)<1)
			strcpy(in_section,"[global]\0");
		set_value(p_arg,get_it,"Yes",in_section);
	}
	return;
}

/* comment some item */
void comment_item(struct ligne **p_arg,char *param,char *where_section)
{
	struct ligne *result = NULL;
	char new_var[MAX_LENGTH_LINE];
	if(p_arg == NULL)
		return;
	if(*p_arg == NULL)
		return;
	/*printf("Looking for %s in -%s-\n",param,where_section);*/
	result = search_var(*p_arg,param,where_section);
	/*printf("Result: ");*/
	if(result != NULL)
	{
		strcpy(new_var,"\0");
		strcat(new_var,"; ");
		strncat(new_var,result->var,MAX_LENGTH_LINE-3);
		strcpy(result->var,new_var);
	}
	/*else
		printf("not found\n");*/
	return;
}
/* Delete a complete section */
void delete_section(struct ligne **p_arg,char *where_section)
{
	struct ligne *result = NULL,
		*next = NULL;
	if(p_arg == NULL)
		return;
	if(*p_arg == NULL)
		return;
	result = search_var(*p_arg,NULL,where_section);
	while(result != NULL)
	{
		next = result->suivant;
		delete_this_item(p_arg,result);
		result = next;
		if(result != NULL)
		{
			if(result->is_section == 0)
				result = NULL;
		}
	}
}
/* delete this item */
void delete_this_item(struct ligne **p_arg,struct ligne *result)
{
	if(p_arg == NULL)
		return;
	if(*p_arg == NULL)
		return;
	if(result != NULL)
	{
		/*printf("found\n");*/
		if(result->suivant != NULL)
			result->suivant->precedent = result->precedent;
		if(result->precedent != NULL)
			result->precedent->suivant = result->suivant;
		/*printf("To be deleted: %s\n",result->var);*/
		if(*p_arg == result)
		{
			*p_arg = NULL;
			/*printf("Was the only item?\n");*/
		}
		free(result);
		result = NULL;
	}
}
/* Delete some item */
void delete_item(struct ligne **p_arg,char *param,char *where_section)
{
	struct ligne *this_item = NULL;
	if(p_arg == NULL)
		return;
	if(*p_arg == NULL)
		return;
	/*printf("Looking for %s in -%s-\n",param,where_section);*/
	this_item = search_var(*p_arg,param,where_section);
	delete_this_item(p_arg,this_item);
	/*printf("Result: ");*/
	/*else
		printf("not found\n");*/
	return;
}

/* Save to file */
int save_all(struct ligne *list_arg, char *save_to)
{
	FILE *file_ptr=NULL;
	file_ptr = fopen(save_to,"w");
	if(file_ptr == NULL)
	{
		/*printf("Error, unable to write the file.\n");*/
		return(1);
	}
	while(list_arg != NULL)
	{
		switch(list_arg->is_section)
		{
			case  1:
				fprintf(file_ptr,"%s",list_arg->var);
				fprintf(file_ptr," = %s\n",list_arg->value);
				break;
			case -2:
			case -1:
			case  0:
			default:
				fprintf(file_ptr,"%s",list_arg->var);
				break;
			/*case -2:
			case -1:
				printf("-do not take count- |");
			default:
				printf("%s",list_arg->var);*/
		}
		list_arg = list_arg->suivant;
	}
	fclose(file_ptr);
	/*printf("File has been saved as: %s\n",save_to);*/
	return(0);
}



