#include <stdlib.h>

#include "struct_ligne.h"
#include "goto_end.h"

#include "move_last_to_first.h"
/* move last item to the first position */
struct ligne * move_last_to_first(struct ligne **p_arg)
{
	struct ligne *list_arg=NULL,*last_item=NULL;
	if(p_arg == NULL)
		return NULL;
	list_arg = *p_arg;
	if(list_arg == NULL)
		return NULL;
	last_item = goto_end(list_arg);
	if(last_item == NULL)
		return NULL;
	if(last_item->precedent == NULL)
		return NULL;
	/* move last to first */
	last_item->suivant = list_arg;
	list_arg->precedent = last_item;
	/* then delete the NEW last -> suivant to NULL */
	last_item->precedent->suivant = NULL;
	/* delete the last_item ->precedent because it is first */
	last_item->precedent = NULL;
	/* First pointer should be on last_item now */
	*p_arg = last_item;
	return last_item;
}
