#include <stdlib.h>
#include <string.h>

#include "struct_ligne.h"

#include "create_line.h"

/* This function use the premz pointer adress to add a new line 
 * from the smb.conf file into the memory list */
struct ligne* create_line(struct ligne **p_arg)
{
	struct ligne * new_ligne=NULL, *current=NULL;
	if(p_arg == NULL)
		return NULL;
	new_ligne = (struct ligne*) malloc(sizeof(struct ligne));
	if(new_ligne == NULL)
		return NULL;
	new_ligne->suivant = NULL;
	new_ligne->precedent = NULL;
	new_ligne->is_section = 6;
	strcpy(new_ligne->value,"\0");
	strcpy(new_ligne->var,"\0");
	if(*p_arg == NULL)
	{
		/* Create the first ligne */
		*p_arg = new_ligne;
	}
	else
	{
		/* Add a ligne at the end */
		current = *p_arg;
		/*while(current->suivant != NULL)
			current = current->suivant;*/
		if(current->suivant != NULL)
		{
			new_ligne->suivant = current->suivant;
			current->suivant->precedent = new_ligne;
		}
		current->suivant = new_ligne;
		new_ligne->precedent = current;
	}
	return new_ligne;
}
