#ifndef __SMBPARSE_STRUCT_LINE_H__
#define __SMBPARSE_STRUCT_LINE_H__


#define MAX_LENGTH_OPTION 256
#define MAX_LENGTH_VALUES 256
#define MAX_LENGTH_LINE 256

/* The structure used in memory to retain the smb.conf file */
struct ligne
{
	char var[MAX_LENGTH_LINE];
	char value[MAX_LENGTH_VALUES];
	int is_section; /* 0 is section, 1 is normal, negative=comment*/
	struct ligne *suivant;
	struct ligne *precedent;
};

#endif /* __SMBPARSE_STRUCT_LINE_H__  */
